/*
 Navicat Premium Data Transfer

 Source Server         : 自己的阿里云3年mysql
 Source Server Type    : MySQL
 Source Server Version : 50734
 Source Host           : 47.108.115.128:3306
 Source Schema         : sharding1

 Target Server Type    : MySQL
 Target Server Version : 50734
 File Encoding         : 65001

 Date: 17/02/2022 15:13:24
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for t_order_2022
-- ----------------------------
DROP TABLE IF EXISTS `t_order_2022`;
CREATE TABLE `t_order_2022`  (
  `id` bigint(18) NOT NULL COMMENT '主键',
  `user_id` bigint(18) NOT NULL COMMENT '用户id',
  `order_num` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '订单编号',
  `money` decimal(20, 0) NULL DEFAULT NULL COMMENT '订单金额',
  `year` int(10) NULL DEFAULT NULL COMMENT '新增年份',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '新增时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_order_2022
-- ----------------------------
INSERT INTO `t_order_2022` VALUES (1494203283296333825, 3, '555', 289, 2022, '2022-01-03 00:00:00');

-- ----------------------------
-- Table structure for t_order_2023
-- ----------------------------
DROP TABLE IF EXISTS `t_order_2023`;
CREATE TABLE `t_order_2023`  (
  `id` bigint(18) NOT NULL COMMENT '主键',
  `user_id` bigint(18) NOT NULL COMMENT '用户id',
  `order_num` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '订单编号',
  `money` decimal(20, 0) NULL DEFAULT NULL COMMENT '订单金额',
  `year` int(10) NULL DEFAULT NULL COMMENT '新增年份',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '新增时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_order_2023
-- ----------------------------
INSERT INTO `t_order_2023` VALUES (1494203317718986753, 4, '907', 341, 2023, '2023-01-03 00:00:00');

-- ----------------------------
-- Table structure for t_user_2022
-- ----------------------------
DROP TABLE IF EXISTS `t_user_2022`;
CREATE TABLE `t_user_2022`  (
  `id` bigint(18) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '姓名',
  `age` int(11) NULL DEFAULT NULL COMMENT '年龄',
  `year` int(10) NULL DEFAULT NULL COMMENT '新增年份',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '新增时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_user_2022
-- ----------------------------
INSERT INTO `t_user_2022` VALUES (3, 'Elisabethfurt', 900, 2022, '2022-02-03 00:00:00');

-- ----------------------------
-- Table structure for t_user_2023
-- ----------------------------
DROP TABLE IF EXISTS `t_user_2023`;
CREATE TABLE `t_user_2023`  (
  `id` bigint(18) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '姓名',
  `age` int(11) NULL DEFAULT NULL COMMENT '年龄',
  `year` int(10) NULL DEFAULT NULL COMMENT '新增年份',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '新增时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of t_user_2023
-- ----------------------------
INSERT INTO `t_user_2023` VALUES (1, 'Steuberhaven', 148, 2023, '2023-02-03 00:00:00');

SET FOREIGN_KEY_CHECKS = 1;
