package com.xin.shardingspherejdbcdemo.config.sharding;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

@Configuration
@ConfigurationProperties(prefix = "mydbinfo")
public class MyDataSourceConfig {
    public static List<MyDataSourcePropertie> list;   //static 才能拿配置值

    public static Map<String, MyDataSourcePropertie> getDataSourceConfig() {
        Map<String, MyDataSourcePropertie> data = new HashMap<>();
        for (MyDataSourcePropertie myDataSourcePropertie : list) {
            data.put(myDataSourcePropertie.getShardingDbName(), myDataSourcePropertie);
        }
        return data;
    }

    public void setList(List<MyDataSourcePropertie> list) {
        MyDataSourceConfig.list = list;
    }
}
